## org.apache.tools.ant.filters
Class HeadFilter

    java.lang.Object
      java.io.Reader
          java.io.FilterReader
              org.apache.tools.ant.filters.BaseFilterReader
                  org.apache.tools.ant.filters.BaseParamFilterReader
                      org.apache.tools.ant.filters.HeadFilter

All Implemented Interfaces:
  ChainableReader, Parameterizable

public final class HeadFilter
extends BaseParamFilterReader
implements ChainableReader

Reads the first `n` lines of a stream. (Default is first 10 lines.)

Example:

    <headfilter lines="3"/>

Or:

    <filterreader classname="org.apache.tools.ant.filters.HeadFilter">
        <param name="lines" value="3"/>
     </filterreader>

Author:
  Magesh Umasankar

Field Summary

Fields inherited from class java.io.FilterReader
`in`

Fields inherited from class java.io.Reader
`lock`

Constructor Summary
`HeadFilter()` Constructor for "dummy" instances.
`HeadFilter(java.io.Reader in)` Creates a new filtered reader.

Method Summary
`java.io.Reader` `chain(java.io.Reader rdr)` Creates a new HeadFilter using the passed in Reader for instantiation.
`int` `read()` Returns the next character in the filtered stream.
`void` `setLines(long lines)` Sets the number of lines to be returned in the filtered stream.

Methods inherited from class org.apache.tools.ant.filters.BaseParamFilterReader
`getParameters, setParameters`

Methods inherited from class org.apache.tools.ant.filters.BaseFilterReader
`getInitialized, getProject, read, readFully, readLine, setInitialized, setProject, skip`

Methods inherited from class java.io.FilterReader
`close, mark, markSupported, ready, reset`

Methods inherited from class java.io.Reader
`read`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### HeadFilter

    public HeadFilter()

  Constructor for "dummy" instances.

See Also:
  `BaseFilterReader.BaseFilterReader()`

### HeadFilter

    public HeadFilter(java.io.Reader in)

  Creates a new filtered reader.

Parameters:
  `in` - A Reader object providing the underlying stream. Must not be `null`.

Method Detail

### read

    public final int read()
                   throws java.io.IOException

  Returns the next character in the filtered stream. If the desired number of lines have already been read, the resulting stream is effectively at an end. Otherwise, the next character from the underlying stream is read and returned.

  Returns:
    the next character in the resulting stream, or -1 if the end of the resulting stream has been reached
  Throws:
    `java.io.IOException` - if the underlying stream throws an IOException during reading

### setLines

    public final void setLines(long lines)

  Sets the number of lines to be returned in the filtered stream.

  Parameters:
    `lines` - the number of lines to be returned in the filtered stream

### chain

    public final java.io.Reader chain(java.io.Reader rdr)

  Creates a new HeadFilter using the passed in Reader for instantiation.

  Specified by:
    `chain` in interface `ChainableReader`
  Parameters:
    `rdr` - A Reader object providing the underlying stream. Must not be `null`.
  Returns:
    a new filter based on this configuration, but filtering the specified reader

Copyright © 2000-2003 Apache Software Foundation. All Rights Reserved.